############################################
#        ::Invisibility by Anto Cvitic  #
#  ==========================================
# Invisibility will block contacts  when they go offline
# and unblock them when they change their state to online
############################################

namespace eval ::Invisibility {

	proc Init { dir } {
		::plugins::RegisterPlugin "Invisibility"
		plugins_log "Invisibility"  "Registered plugin"

		::plugins::RegisterEvent "Invisibility" ChangeState blockContact
#		::plugins::RegisterEvent "Invisibility" UserConnect unBlockContact
		plugins_log "Invisibility"  "Registered events"

	}
	proc blockContact { event evpar } {

		upvar 2 user user
		upvar 2 substate substate
		plugins_log "Invisibility" "user is: $user and substate is: $substate"
		#puts "user: $user and substate: $substate"

		if {$substate == "FLN"} {
			set name [::abook::getNick ${user}]
			::MSN::blockUser ${user} [urlencode $name]
			after 500 ::Event::fireEvent contactStateChange protocol $user
			plugins_log "Invisibility"  "blocked $user"
		}

		if {$substate == "NLN"} {
			after 1000
			set name [::abook::getNick ${user}]
			::MSN::unblockUser ${user} [urlencode $name]
			after 500 ::Event::fireEvent contactStateChange protocol $user
			plugins_log "Invisibility"  "unblocked $user"
		}

	}
	proc deInit { } {
		::plugins::UnRegisterEvents "Invisibility"
		plugins_log "Invisibility" "plugin unregistered"
	}
}

